package gerhard.Location;



import java.util.ArrayList;
import java.util.List;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class FindLocation extends Activity {
	private static final String TAG = "FindLocation";
	private WifiManager wifi;
	private BroadcastReceiver receiver;
	private NetworkIO io;
	private Button btn;
	private Button btn2;
	private String[] coords;
	private long time;
	private long timeNetworkScan;
	private long sendToServerTime;
	
	
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
    	this.setContentView(R.layout.findlocation);
    	this.btn = (Button)this.findViewById(R.id.btn);
    	this.btn2 =(Button)this.findViewById(R.id.btn2);
    	io = new NetworkIO();
    	if (receiver == null){
			receiver = new WiFiScan(this);
    	}
    	wifi = (WifiManager) getSystemService(Context.WIFI_SERVICE);
        registerReceiver(receiver, new IntentFilter(WifiManager.SCAN_RESULTS_AVAILABLE_ACTION));
    	this.btn.setOnClickListener(new OnClickListener(){
    		public void onClick(View v) {
    			time = 0;
    			coords = null;
    			wifi.startScan();
    			time = System.currentTimeMillis();
    			Log.d(TAG, "SKAL HA STARTET WIFI SCAN!!!!!!");
      	    }
    	});
    	this.btn2.setOnClickListener(new OnClickListener() {
			
			public void onClick(View v) {
				finish();	
			}
		});
    }
    	
    public void GetAndDisplayLocationEstimate(List<ScanResult> accessPoints){
		Log.d(TAG, "INNE I DISPLAY NETWORK INFO !!!");
    	List<ScanResult> result = accessPoints;
		List<ScanResult> eduRoamAp = new ArrayList<ScanResult>();
		for(int i = 0; i<result.size(); i++){
			if(result.get(i).SSID.equals("eduroam")){
				ScanResult mid = result.get(i);
				mid.level = mid.level*-1;
				eduRoamAp.add(mid);
			}
		}
		List<ScanResult> edu = sortAccessPoints(eduRoamAp);
		timeNetworkScan = System.currentTimeMillis();
		Log.d(TAG, "TIME NETWORK SCAN AND SORT = "+(timeNetworkScan-time));
		io.sendToServer(edu.get(0).BSSID+" "+edu.get(0).level+" "+edu.get(1).BSSID+" "+edu.get(1).level+" "+edu.get(2).BSSID+" "+edu.get(2).level);
		String fromServer = io.listenToConnection();
		sendToServerTime = System.currentTimeMillis();
		Log.d(TAG, "TIME SEND TO SERVER = "+(sendToServerTime-timeNetworkScan));
		io.closeConnection();
		Log.d(TAG, "HAR MOTATT FRA SERVEREN !!!");
		coords = fromServer.split("\\s+");
		//ta inn y koordinat frst s x koordinat
		Intent i = new Intent(FindLocation.this, MapDisplay.class);
		i.putExtra("xcoord", Integer.parseInt(coords[1]));
		i.putExtra("ycoord",Integer.parseInt(coords[0]));
		i.putExtra("zcoord",Integer.parseInt(coords[2]));
		i.putExtra("time", time);
		i.putExtra("sendToServerTime", sendToServerTime);
		Log.d(TAG, "SKAL TIL OG STARTE ACTIVITETEN !!!");
		startActivity(i);
	}

	public void setWifi(WifiManager wifi) {
		this.wifi = wifi;
	}


	public WifiManager getWifi() {
		return wifi;
	}

	public List<ScanResult> sortAccessPoints(List<ScanResult> result){
		for(int i = 1; i< result.size(); i++){
			for(int j = 0; j< i; j++){
				if(result.get(i).level < result.get(j).level){					
					ScanResult save =  result.get(i);
					result.remove(i);
					result.add(j, save);
					break;
					}
				}
			}
		return result;	
	}
}