package locationServer;

import java.util.ArrayList;
import java.util.List;


/**
 * @author Gerhard Wiese
 * 
 * The Calculator class is responsible for doing calculations in the Location system.
 *
 */
public class Calculator {
	 int rssi1 = 0; 
	 int rssi2 = 0;
	 int rssi3 = 0;
	 int rssitest1 = 0;
	 int rssitest2 = 0;
	 int rssitest3 = 0;
	 int topRate;
 /**
  * euclideanDistance will calculate the euclidean distance for all the {@link Location} objects in the input {@link ArrayList}, 
  * compared to the the values stored in the accessPoints {@link ArrayList} in {@link MainSystem}. The calculation is done in 
  * reference to the Rssi values. Each {@link Location} object contains a {@link ArrayList} of {@link AccessPoint}. 
  * accessPoints in {@link MainSystem} also contain {@link AccessPoint} objects.
  * 
  * 
  * The method will return the locationid of the {@link Location} corresponding to the smallest euclidean distance. 
  * 
 * @param locations a {@link ArrayList} of {@link Location} objects. 
 * @return The id of the {@link Location} object corresponding to the smallest euclidean distance
 * @see Location
 * @see ArrayList
 * @see MainSystem
 * @see AccessPoint
 */
/*	 
public int euclideanDistance(ArrayList<Location> locations, ArrayList<AccessPoint> accessPoints){	
	int location = 0;
	 double edistance = 1000;
	 for(int i=0; i<locations.size(); i++){ 
		// System.out.println("LOKASJON = "+i);
		 for(int j = 0; j<locations.get(i).AccessPoints.size(); j++){
			// System.out.println("RSSI = "+ locations.get(i).AccessPoints.get(j).getRssi()); 
			 if(accessPoints.get(0).getBssi().equals(locations.get(i).AccessPoints.get(j).getBssi())){
				 rssitest1 = locations.get(i).AccessPoints.get(j).getRssi();
				 rssi1 = accessPoints.get(0).getRssi();
			 }
			 else if(accessPoints.get(1).getBssi().equals(locations.get(i).AccessPoints.get(j).getBssi())){
				 rssitest2 = locations.get(i).AccessPoints.get(j).getRssi();
				 rssi2 = accessPoints.get(1).getRssi();
			 }
			 else if(accessPoints.get(2).getBssi().equals(locations.get(i).AccessPoints.get(j).getBssi())){
				 rssitest3 = locations.get(i).AccessPoints.get(j).getRssi(); 
				 rssi3 = accessPoints.get(2).getRssi();
			 }
		 }
		 double distance = Math.sqrt(Math.pow((rssi1-rssitest1),2)+Math.pow((rssi2-rssitest2),2)+Math.pow((rssi3-rssitest3),2));
		 rssi1 = 0; 
		 rssi2 = 0;
		 rssi3 = 0;
		 rssitest1 = 0;
		 rssitest2 = 0;
		 rssitest3 = 0;
		 if(distance<edistance){
			  edistance = distance; 
			  location = locations.get(i).getLocationId();
		  }
	 }
	return location; 
	 }
*/
	 
	 
public ArrayList<Location> locationRating(ArrayList<Location> locations,ArrayList<AccessPoint> accessPoints){
	topRate = 0;
	ArrayList<Location> loc = locations;
	for(int i = 0; i < loc.size(); i ++){
		int rating = 0;
		if(accessPoints.get(0).getBssi().equals(loc.get(i).AccessPoints.get(0).getBssi())){
			rating = rating + 4;
		}
		if(accessPoints.get(1).getBssi().equals(loc.get(i).AccessPoints.get(1).getBssi())){
			rating = rating + 2;
		}
		if(accessPoints.get(2).getBssi().equals(loc.get(i).AccessPoints.get(2).getBssi())){
			rating = rating + 1;
		}
		System.out.println("DETTE ER RATINGEN = "+rating);
		loc.get(i).setRating(rating);
		if(rating > topRate){
			topRate = rating;
		}
	}
	return loc;	
}

public int euclideanDistance(ArrayList<Location> locations, ArrayList<AccessPoint> accessPoints){	
	ArrayList<Location> loc = locationRating(locations, accessPoints);
	int location = 0;
	 double edistance = 1000;
	 System.out.println("TOPRATE = "+topRate);
	 for(int i=0; i<loc.size(); i++){ 
		if(loc.get(i).getRating() == topRate){
		 for(int j = 0; j<loc.get(i).AccessPoints.size(); j++){ 
			 if(accessPoints.get(0).getBssi().equals(loc.get(i).AccessPoints.get(j).getBssi())){
				 rssitest1 = loc.get(i).AccessPoints.get(j).getRssi();
				 rssi1 = accessPoints.get(0).getRssi();
			 }
			 else if(accessPoints.get(1).getBssi().equals(loc.get(i).AccessPoints.get(j).getBssi())){
				 rssitest2 = loc.get(i).AccessPoints.get(j).getRssi();
				 rssi2 = accessPoints.get(1).getRssi();
			 }
			 else if(accessPoints.get(2).getBssi().equals(loc.get(i).AccessPoints.get(j).getBssi())){
				 rssitest3 = loc.get(i).AccessPoints.get(j).getRssi(); 
				 rssi3 = accessPoints.get(2).getRssi();
			 }
		 }
		 double distance = Math.sqrt(Math.pow((rssi1-rssitest1),2)+Math.pow((rssi2-rssitest2),2)+Math.pow((rssi3-rssitest3),2));
		 System.out.println("inne i euklid");
		 rssi1 = 0; 
		 rssi2 = 0;
		 rssi3 = 0;
		 rssitest1 = 0;
		 rssitest2 = 0;
		 rssitest3 = 0;
		 if(distance<edistance){
			  edistance = distance; 
			  location = locations.get(i).getLocationId();
		  }
	 }
	 }
	return location;
	 
	 }




}
