package locationServer;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.sql.SQLException;
import java.util.ArrayList;

public class ClientHandler implements Runnable {

private Socket client;
private long time;

public ClientHandler(Socket client){
	this.client = client;
	this.time = System.currentTimeMillis();
}
	
	
public void run() {
	String result = null;
	ArrayList<AccessPoint> accessPoints = new ArrayList<AccessPoint>();
	BufferedReader input = null;
	PrintWriter output = null;
	 try{
	      input = new BufferedReader(new InputStreamReader(client.getInputStream()));
	      output = new PrintWriter(client.getOutputStream(), true);
	    } 
	 catch (IOException e) {
	      System.out.println("in or out failed");
	      System.exit(-1);
	    }
	    while(true){
	        try{
	        	//LESER INN INFOMASJONEN FRA KLIENTEN
	         String fromClient = input.readLine();
	         String[] networkInfo = fromClient.split("\\s+");
	         for(int i = 0; i<6;){
		         AccessPoint acc = new AccessPoint();
		         acc.setBssi(networkInfo[i]);
		         //skriv om til mer forstelig kode!!
		         if(!(Character.isDigit(acc.getBssi().charAt(0)))){
		        	 String bssid =acc.getBssi().charAt(1)+acc.getBssi().charAt(2)+":"+acc.getBssi().charAt(4)+acc.getBssi().charAt(5)+":"+acc.getBssi().charAt(7)+acc.getBssi().charAt(8)+":"+acc.getBssi().charAt(10)+acc.getBssi().charAt(11)+":"+acc.getBssi().charAt(13)+acc.getBssi().charAt(14)+":"+acc.getBssi().charAt(16)+acc.getBssi().charAt(17)+":"+acc.getBssi().charAt(19)+acc.getBssi().charAt(20);
		        	 bssid = removeCharAt(bssid, 0);
		        	 bssid = removeCharAt(bssid, 0);
		        	 System.out.println("Mtte forandre bssiden til ="+bssid);
		        	 acc.setBssi(bssid);
		         }
		         System.out.println(networkInfo[i]);
		         acc.setRssi(Integer.parseInt(networkInfo[i+1]));
		         System.out.println(networkInfo[i+1]);
		         acc.setSsid("eduroam");
		         accessPoints.add(acc); 
	        	 i = i+2;
	         }
	         try {
	        	 result = MainSystem.dbReader.findLocation(accessPoints);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			//SENDER SVAR TIL KLIENTEN
			output.println(result);
			long timeUsed = (System.currentTimeMillis() - time);
			System.out.println("THE USED "+timeUsed+" TO ESTIMATE THE LOCATION");
			output.close();
			System.out.println("har sendt data "+result);
	           break;
	         } 
	        catch (IOException e) {
	           System.out.println("Read failed");
	           System.exit(-1);
	         }  
	    }
	}
public static String removeCharAt(String s, int pos) {
    return s.substring(0,pos)+s.substring(pos+1);
    }

}
