package locationServer;


/**
 * @author	Gerhard Wiese
 * 
 * 
 * The MainSystem class is the core of the location system. 
 * Having instances of the different components used in the system 
 *
 */
public class MainSystem {

static DataBaseReader dbReader;	
static Calculator calc;
static NetworkIO io;

	/**
	 * Constructor of the MainSystem class initializing the different components
	 * of the location system: {@link Gui}, {@link DataBaseReader}, {@link NetworkReader} and {@link Calculator}
	 * 
	 * @see DataBaseReader
	 * @see NetworkReader
	 * @see Gui
	 * @see Calculator
	 */
	public MainSystem(){
		dbReader = new DataBaseReader();
		io = new NetworkIO();
		calc = new Calculator();
		dbReader.connectToDB();
		io.run();
	}


	/**
	 * This method starts up the location system, by calling the 
	 * constructor of the MainSystem class.
	 * 
	 * @param args
	 */
	public static void main( String [  ]  args ) {
			new MainSystem();
			

	}






}
