package Location;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;


/*
 Start opp databasen i terminalvinduet med flgende kommandoer : If you have installed the Startup Item, use this command:

shell> cd /usr/local/mysql
shell> sudo ./bin/mysqld_safe
(Enter your password, if necessary)
(Press Control-Z)
shell> bg
(Press Control-D or enter "exit" to exit the shell)
*/

/**
 * @author Gerhard Wiese
 * 
 * The DataBaseReader handles all contact with the database in the Location package. 
 *
 */
public class DataBaseReader {
	private Connection con = null;
	private String url = "jdbc:mysql://localhost:3306/";
	private String dbName = "TestLoc";
	private String driver = "com.mysql.jdbc.Driver";
	private String userName = "root"; 
	private String password = "";
	private int xcoord; 
	private int ycoord;
	private int zcoord;
	static long euclid;
	
	/**
	 * Creates a connection to the specific database, defined by the variables sat i the {@link DataBaseReader} class,
	 * and for logging on to the MySQL database.
	 */
	public void connectToDB(){
		try {
			  Class.forName(driver).newInstance();
			  con = DriverManager.getConnection(url+dbName,userName,password);
			  System.out.println("Connected to the database");			  
			} 
		catch (Exception e) {
			  e.printStackTrace();
			}
	}
	
	/**
	 * Disconnects from the MySQL database. 
	 * 
	 * @throws SQLException
	 */
	public void dissconnectDB() throws SQLException{
		con.close();
		System.out.println("Dissconnected from database");
	}
	
//THE METHOD USED FOR INSERTING INFO INTO DATABASE WHILE MAPPING TO LOCATIONS WILL HAVE TO BE MODIFIED IN ORDER TO USE BECASE OF CHANGE IN DB STRUCURE	
	
	

	public void registerLocation(int x, int y, int z ) throws SQLException{
		int acc_id;
		int fpid1 = 0;
		int fpid2 = 0;
		int fpid3 = 0; 
		MainSystem.dbReader.connectToDB();
		Statement testStatement = con.createStatement();
		if(MainSystem.accessPoints.size()>=3){
			System.out.println("flere enn 3 aksesspunkt tilgjengelig");
			
			for(int i = 0; i< 3; i++){
				String check =  MainSystem.accessPoints.get(i).getBssi(); 	
				
				testStatement.executeQuery("SELECT id FROM AccessPoint WHERE bssid=\""+check+"\"");
				ResultSet result = testStatement.getResultSet();
				
				if(result.next() == false){
					testStatement.executeUpdate("INSERT INTO AccessPoint(bssid) VALUES(\""+check+"\")");
					System.out.println("La inn aksesspunkt i databasen");
					testStatement.executeQuery("SELECT id FROM AccessPoint WHERE bssid=\""+check+"\"");
					ResultSet accresult = testStatement.getResultSet();
					accresult.next();
					acc_id = accresult.getInt("id");
					System.out.println("Acc_id ="+acc_id);
				}
				else{
					acc_id = result.getInt("id");
					System.out.println("Acc_id="+acc_id);
				
				}
				testStatement.executeUpdate("INSERT INTO FingerPrint(acc_id,rssi) VALUES("+acc_id+","+MainSystem.accessPoints.get(i).getRssi()+")");
				
				System.out.println("La inn Fingerprint i databasen");
				testStatement.executeQuery("SELECT id FROM FingerPrint");
				ResultSet fingresult = testStatement.getResultSet();
				fingresult.last();
				int mid = fingresult.getInt("id");
				System.out.println("Fingerprint id="+mid);
					if(i==0){
						fpid1 = mid;
					}
					if(i==1){
						fpid2 = mid;
					}
					if(i==2){
						fpid3 = mid;
					}
					
			}	
				testStatement.executeUpdate("INSERT INTO Location(cordx,cordy,cordz) VALUES("+x+","+y+","+z+")");
				System.out.println("La inn Lokasjon i databasen");
				testStatement.executeQuery("SELECT id FROM Location");
				ResultSet locresult = testStatement.getResultSet();
				locresult.last();
				int loc_id = locresult.getInt("id");
				System.out.println("Lokasjonsid="+loc_id);
				testStatement.executeUpdate("INSERT INTO Relations VALUES("+loc_id+","+fpid1+","+fpid2+","+fpid3+")");
				System.out.println("La inn relasjon i databasen");
				MainSystem.regGui.result.setText("Location with id="+loc_id+ "was added to the system");
		}
		else{
			System.out.println("mindre enn tre aksesspunkt tilgjengelig");
			
			for(int i =0; i<MainSystem.accessPoints.size(); i++){
				String check =  MainSystem.accessPoints.get(i).getBssi(); 
				testStatement.executeQuery("SELECT id FROM AccessPoint WHERE bssid=\""+check+"\"");
				ResultSet result = testStatement.getResultSet();
				
				if(result.next() == false){
					testStatement.executeUpdate("INSERT INTO AccessPoint(bssid) VALUES(\""+check+"\")");
					System.out.println("La inn aksesspunkt i databasen");
					testStatement.executeQuery("SELECT id FROM AccessPoint WHERE bssid=\""+check+"\"");
					ResultSet accresult = testStatement.getResultSet();
					accresult.next();
					acc_id = accresult.getInt("id");
					System.out.println("Acc_id ="+acc_id);
				}
				else{
					acc_id = result.getInt("id");
					System.out.println("Acc_id="+acc_id);
				
				}
					testStatement.executeUpdate("INSERT INTO FingerPrint(acc_id,rssi) VALUES("+acc_id+","+MainSystem.accessPoints.get(i).getRssi()+")");
					System.out.println("La inn Fingerprint i databasen");
					testStatement.executeQuery("SELECT id FROM FingerPrint");
					ResultSet fingresult = testStatement.getResultSet();
					fingresult.last();
					int mid = fingresult.getInt("id");
					System.out.println("Fingerprint id="+mid);
						if(i==0){
							fpid1 = mid;
						}
						if(i==1){
							fpid2 = mid;
						}
						if(i==2){
							fpid3 = mid;
						}

			}
			testStatement.executeUpdate("INSERT INTO Location(cordx,cordy,cordz) VALUES("+x+","+y+","+z+")");
			System.out.println("La inn Lokasjon i databasen");
			testStatement.executeQuery("SELECT id FROM Location");
			ResultSet locresult = testStatement.getResultSet();
			locresult.last();
			int loc_id = locresult.getInt("id");
			System.out.println("Lokasjonsid="+loc_id);
			testStatement.executeUpdate("INSERT INTO Relations VALUES("+loc_id+","+fpid1+","+fpid2+","+fpid3+")");
			System.out.println("La inn relasjon i databasen");
			MainSystem.regGui.result.setText("Location with id="+loc_id+ "was added to the system");
		}
		
		MainSystem.dbReader.dissconnectDB();
	}




	/**
	 * The method is used for inserting information about a location in to the MySQL database.
	 * It takes in three parameters from the {@link RegisterLocationGui} and will read in the additional
	 * information from the accessPoints {@link ArrayList} in {@link MainSystem}.
	 * 
	 * @see RegisterLocationGui
	 * @see ArrayList
	 * @see MainSystem
	 * @param x The x coordinate corresponding to the current location of the user device.
	 * @param y The y coordinate corresponding to the current location of the user device.
	 * @param z The z coordinate corresponding to the current location of the user device.
	 * @throws SQLException
	 */
	
	
	public void regLoc(int x, int y, int z ) throws SQLException{
		if(MainSystem.accessPoints.size()>=3){
			System.out.println("flere enn 3 aksesspunkt tilgjengelig");
			int acc_id;
			int loc_id;
			MainSystem.dbReader.connectToDB();
			Statement testStatement = con.createStatement();
			testStatement.executeUpdate("INSERT INTO Location(cordx,cordy,cordz) VALUES("+x+","+y+","+z+")");
			System.out.println("La inn Lokasjon i databasen");
			testStatement.executeQuery("SELECT id FROM Location");
			ResultSet locresult = testStatement.getResultSet();
			locresult.last();
			loc_id = locresult.getInt("id");
			System.out.println("Lokasjonsid="+loc_id);		
			
			for(int i = 0; i< 3; i++){
				String check =  MainSystem.accessPoints.get(i).getBssi(); 	
				testStatement.executeQuery("SELECT id FROM AccessPoint WHERE bssid=\""+check+"\"");
				ResultSet result = testStatement.getResultSet();	
				if(result.next() == false){
					testStatement.executeUpdate("INSERT INTO AccessPoint(bssid) VALUES(\""+check+"\")");
					System.out.println("La inn aksesspunkt i databasen");
					testStatement.executeQuery("SELECT id FROM AccessPoint WHERE bssid=\""+check+"\"");
					ResultSet accresult = testStatement.getResultSet();
					accresult.next();
					acc_id = accresult.getInt("id");
					System.out.println("Acc_id ="+acc_id);
				}
				else{
					acc_id = result.getInt("id");
					System.out.println("Acc_id="+acc_id);
				
				}
				testStatement.executeUpdate("INSERT INTO FingerPrint2(acc_id,rssi,loc_id) VALUES("+acc_id+","+MainSystem.accessPoints.get(i).getRssi()+","+loc_id+")");			
				System.out.println("La inn Fingerprint i databasen");	
			}	
				MainSystem.regGui.result.setText("Location with id="+loc_id+ "was added to the system");
				MainSystem.dbReader.dissconnectDB();
		}
		else{
			System.out.println("DET VAR FRRE ENN TRE AKSESSPUNKT");
			MainSystem.regGui.result.setText("Less then 3 accesspoints available");
		}
	}


}