//
//  LocationViewController.m
//  Location
//
//  Created by Gerhard Wiese on 03.02.10.
//  Copyright NTNU 2010. All rights reserved.
//

#import "LocationViewController.h"
#import "AccessPoint.h"
#import "WiFiReader.h"
#import "LXSocket.h"

@implementation LocationViewController


-(IBAction)buttonPressed:(id)sender{
	socket = [[LXSocket alloc] init];
	[self locationLookUp];
	
 
}

- (void) locationLookUp{
	startTime = [NSDate timeIntervalSinceReferenceDate];
	NSString * answer = [[NSString alloc] init];
	[reader scanNetworks];
	NSMutableArray * result = [reader getNetworksInfo];
	//NSLog(@"har mottatt alle aksesspunktene skal sorteres");
	NSMutableArray * sorted = [reader sortAccessPoints:result];	
	scanTime = [NSDate timeIntervalSinceReferenceDate];
	NSLog(@"THE TIME OF FASE 1 = %f",((scanTime - startTime)*1000));
	//NSLog(@"Antall aksesspunkt etter sort = %d", [sorted count]);
	//NSLog(@"sorteringen er ferdig");
	NSString * toServer = [[NSString alloc] initWithString:[[sorted objectAtIndex:0] BSSID]];
	for(int i = 0; i < 3; i ++){
			if(i ==0){
			toServer = [toServer stringByAppendingString:@" "];
			NSString* intString = [NSString stringWithFormat:@"%d", [[sorted objectAtIndex:i] RSSI]];
			toServer = [toServer stringByAppendingString:intString];
			toServer = [toServer stringByAppendingString:@" "];
			}
			else if(i == 2){
				toServer = [toServer stringByAppendingString:[[sorted objectAtIndex:i] BSSID]];
				toServer = [toServer stringByAppendingString:@" "];
				NSString* intString = [NSString stringWithFormat:@"%d", [[sorted objectAtIndex:i] RSSI]];
				toServer = [toServer stringByAppendingString:intString];
				toServer = [toServer stringByAppendingString:@"\n"];
			}
			else{
				toServer = [toServer stringByAppendingString:[[sorted objectAtIndex:i] BSSID]];
				toServer = [toServer stringByAppendingString:@" "];
				NSString* intString = [NSString stringWithFormat:@"%d", [[sorted objectAtIndex:i] RSSI]];
				toServer = [toServer stringByAppendingString:intString];
				toServer = [toServer stringByAppendingString:@" "];
			}
	}
	//NSLog(@"Dette sendes til serveren: %@",toServer);
	[self createSocketConnection];
	answer = [self communicateWithServer: toServer];
	serverTime = [NSDate timeIntervalSinceReferenceDate];
	NSLog(@"THE TIME OF FASE 2 = %f",((serverTime - scanTime)*1000));
	//NSLog(@"Dette kom fra serveren: %@",answer);
	NSArray *coords = [self retrieveCoordinates:answer];
	[socket release];
	UIImage *finalImg = [self displayImage:[[coords objectAtIndex:1] intValue]:[[coords objectAtIndex:0] intValue]:[[coords objectAtIndex:2] intValue]];
	[imgView setImage:finalImg];
	NSTimeInterval totalTime = [NSDate timeIntervalSinceReferenceDate];
	NSLog(@"THE TIME OF FASE 3 = %f",((totalTime - serverTime)*1000));
	NSLog(@"THE TOTAL TIME FOR LOCATION ESTIMATE IS: %f",((totalTime - startTime)*1000));
}


- (void)viewDidLoad {
	[super viewDidLoad];
	reader = [[WiFiReader alloc] init];
	//socket = [[LXSocket alloc] init];
	//[self createSocketConnection];
	NSLog(@"DA STARTER VI");
}	
	

- (UIImage *)displayImage:(int) xcoord:(int) ycoord:(int)zcoord{
	int xStartPoint;
	int yStartPoint;
	UIImage *imageToCrop;
	int pixMeter = 15;
	if(zcoord == 1){
		imageToCrop = [UIImage imageWithContentsOfFile: [[NSBundle mainBundle] pathForResource:@"first" ofType:@"png"]];
		xStartPoint = 1560;
		yStartPoint = 1392;
	}
	if(zcoord==2){
		imageToCrop = [UIImage imageWithContentsOfFile: [[NSBundle mainBundle] pathForResource:@"andre" ofType:@"png"]];
		xStartPoint = 1580;
		yStartPoint = 1290;
	}
	int y = (yStartPoint-(pixMeter*ycoord))-250;
	int x = (xStartPoint-(pixMeter*xcoord))-150;
	//stiller hvor bildet skal croppes og hvor stor del som skal velges ut
	CGRect rect = CGRectMake(x, y, 320,480);
	CGImageRef imageRef = CGImageCreateWithImageInRect([imageToCrop CGImage], rect);
	UIImage *cropped = [UIImage imageWithCGImage:imageRef];
	CGImageRelease(imageRef);
	CGColorSpaceRef colorSpace = CGColorSpaceCreateDeviceRGB();
	CGContextRef context = CGBitmapContextCreate(NULL, cropped.size.width, cropped.size.height, 8, 4*cropped.size.width, colorSpace, kCGImageAlphaPremultipliedFirst);
	CGContextDrawImage(context, CGRectMake(0, 0, cropped.size.width, cropped.size.height), cropped.CGImage);
	//stiller størrelse og hvor prikken skal være
	CGRect leftOval = {155, 225, 10, 10};
	CGContextSetRGBFillColor(context, 1.0, 0.0, 0.0, 1.0);
	CGContextAddEllipseInRect(context, leftOval);
	CGContextFillPath(context);
	
	CGImageRef imageMasked = CGBitmapContextCreateImage(context);
	CGContextRelease(context);
	CGColorSpaceRelease(colorSpace);
	
	return [UIImage imageWithCGImage:imageMasked];	
}


-(void) createSocketConnection{
	if ([socket connect: @"78.91.4.159" port: 8888] == NO) { 
		[socket release]; 
		NSLog(@"cannot create socket"); 
	} else {
		NSLog(@"Created Socket");
	}
}
-(NSString *) communicateWithServer:(NSString *) stringToServer {
	NSString *fromServer;
	[socket sendString: stringToServer];
	//NSLog(@"Har sendt info til server");
	@try {
		//NSLog(@"inne i try"); 
		fromServer = [[NSString alloc] initWithString:[socket readString]];
		//NSLog(@"Her er stringen %@",fromServer);
	}
	@catch (NSException * e) {
		NSLog(@"Could not recieve text");
	}
	@finally {
	}
	return fromServer;
}
-(NSArray *) retrieveCoordinates:(NSString *) serverString {
	NSLog(serverString);
	NSArray *split = [serverString componentsSeparatedByString:@" "];
	return split;
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}
/*
- (id) timer: (NSTimeInterval) timer_value{
	timer = timer_value;
	return self;
}

-(NSTimeInterval) timer{
	return timer;	
}
*/

- (void)dealloc {
    [super dealloc];
}

@end
