//
//  WiFiReader.h
//  Location
//
//  Created by Gerhard Wiese on 19.02.10.
//  Copyright 2010 NTNU. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreFoundation/CoreFoundation.h>
#include <dlfcn.h>
#include "AccessPoint.h"

@interface WiFiReader : NSObject {
	NSMutableDictionary *networks; //Key: MAC Address (BSSID)
	
	void *libHandle;
	void *airportHandle;    
	int (*apple80211Open)(void *);
	int (*apple80211Bind)(void *, NSString *);
	int (*apple80211Close)(void *);
	int (*associate)(void *, NSDictionary*, NSString*);
	int (*apple80211Scan)(void *, NSArray **, void *);
}

- (NSDictionary *)networks;                                                             //returns all 802.11 scanned network(s)
- (NSDictionary *)network:(NSString *) BSSID;                   //return specific 802.11 network by BSSID (MAC Address)
- (void)scanNetworks;
- (int)numberOfNetworks;
- (NSMutableArray *) sortAccessPoints:(NSMutableArray*) AccessPoints;
- ( NSMutableArray * ) getNetworksInfo;
-(NSString *) changeBssidFormat:(NSString *) orgBssid;

@end
